#!/bin/sh

javac -cp .:/tmp/saxon9he.jar XPathEvalSaxon.java
for xml in *.xml
do
    QUERIES="${xml}.queries"
    RESULTS="${xml}.results"
    cat "$QUERIES" | grep -v '^#' | while read qname query
    do
        printf "Generating reference for %s, %s ... " "${xml}" "${qname}"
        java -cp .:/tmp/saxon9he.jar XPathEvalSaxon "${xml}" "${query}" > "$RESULTS"/"${qname}_saxon.xml" 2> "$RESULTS"/"${qname}_saxon.log"
        if [ $? -eq 0 ]
        then
            printf "ok\\n"
        else
            printf "ERROR\\n"
        fi
    done
done
